﻿@using SPAWebApp.Client.Services.Contracts
@using SPAWebApp.Shared
@using SPAWebApp.Shared.Models
@using SPAWebApp.Shared.Models.Services.ConstructDocument
@using SPAWebApp.Shared.Models.Services.Product
@using SPAWebApp.Shared.Models.Services.Relationship
@using SPAWebApp.Shared.Models.ViewModels;
@using SPAWebApp.Shared.Models.ViewModels.ConstructDocument
@using SPAWebApp.Shared.Services
@using IConstructDocumentService = SPAWebApp.Client.Services.Contracts.IConstructDocumentService
@inject IConstructDocumentService ConstructDocumentService
@inject IProductCardService ProductCardService

  <section class="content-files">
    @if (AddState == false)
    {
      @if (ChangeState == false)
      {
        <div class="top-menu">
          <button class="btn btn-info" title="Изменить" onclick="@(() => ChangePageState(true))"><i class="fas fa-pen-fancy"></i></button>
          <button class="btn btn-info" title="Экспорт"><i class="fas fa-file-excel"></i></button>
          <button class="btn btn-info" title="Удалить" onclick="@(() => Remove(Document.Id))"><i class="fas fa-trash-alt"></i></button>
          <button class="btn btn-info" title="Предыдущее состояние" disabled="@DisabledLeft" onclick="@(() => ChangeDocumentState(LeftState, Document.Id))"><i class="fas fa-arrow-left"></i>@LeftState</button>
          <span class="state-label">@Document.State</span>
          <button class="btn btn-info" title="Следующее состояние" disabled="@DisabledRight" onclick="@(() => ChangeDocumentState(RightState, Document.Id))">@RightState <i class="fas fa-arrow-right"></i></button>
          <button class="btn btn-info" title="Новая версия" disabled="@NewVersionCheck" onclick="@(() => CreateNewVersionDocument())"><i class="fas fa-code-branch"></i></button>
          <button class="btn btn-info" title="Подключить"><i class="fas fa-paperclip" onclick="@(() => ChangeAddState())"></i></button>
        </div>
        <table class="k-table">
          <tr>
            <td>id</td>
            <td>@Document.Id</td>
          </tr>
          <tr>
            <td>Обозначение</td>
            <td>@Document.Designation</td>
          </tr>
          <tr>
            <td>Версия</td>
            <td>@Document.Revision</td>
          </tr>
          <tr>
            <td>Состояние</td>
            <td>@Document.State</td>
          </tr>
          <tr>
            <td>Наименование</td>
            <td>@Document.Name</td>
          </tr>
          <tr>
            <td>Файлы</td>
            <td></td>
          </tr>
        </table>
      }
      else
      {
        <ChangeDocumentForm Document="@Document" />
      }
      if (RelatedProducts != null)
      {
        <table class="k-table">
          <thead class="k-thead">
          <tr class="table-headers k-tr">
            <th class="k-th">Обозначение</th>
            <th class="k-th">Версия</th>
            <th class="k-th">Состояние</th>
            <th class="k-th">Наименование</th>
            <th class="k-th">Файлы</th>
          </tr>
          </thead>
          <tbody>
            @foreach (var product in RelatedProducts)
             {
               <tr class="hand-hover k-tr">

                 <td class="k-td">@product.Designation</td>
                 <td class="k-td">@product.Version</td>
                 <td class="k-td">@product.State</td>
                 <td class="k-td">@product.Name</td>
                 <td class="k-td"></td>
               </tr>
             }
         

          </tbody>
        </table>
      }
    }
    else
    {
      if (RelProduct == null)
      {
        <table class="k-table">
          <thead class="k-thead">
          <tr class="table-headers k-tr">
            <th class="k-th">Обозначение</th>
            <th class="k-th">Версия</th>
            <th class="k-th">Состояние</th>
            <th class="k-th">Наименование</th>
            <th class="k-th">Файлы</th>
          </tr>
          </thead>
          <tbody>
          @if (Products != null)
          {
            @foreach (var product in Products)
             {
               <tr class="hand-hover k-tr" onclick="@(() => SelectProductForRel(product))">

                 <td class="k-td">@product.Designation</td>
                 <td class="k-td">@product.Version</td>
                 <td class="k-td">@product.State</td>
                 <td class="k-td">@product.Name</td>
                 <td class="k-td"></td>
               </tr>
             }
          }

          </tbody>
        </table>
      }
      else
      {
  <EditForm Model="@CreateNewRelModel" OnValidSubmit="@(async () => await CreateNewRelAsync())">
    <div class="form-group row">
      <label for="InputText" class="col-sm-2 col-form-label">Document Id</label>
      <div class="col-sm-10">
        <input type="text" class="form-control" placeholder="@Document.Id" value="@Document.Id" bind="@CreateNewRelModel.DocumentId"/>
      </div>
    </div>
    <div class="form-group row">
      <label for="InputText" class="col-sm-2 col-form-label">Product Id</label>
      <div class="col-sm-10">
        <input type="text" class="form-control" placeholder="@RelProduct" value="@RelProduct" bind="@CreateNewRelModel.ProductId"/>
      </div>
    </div>
    <div class="form-group row">
      <label for="InputText" class="col-sm-2 col-form-label">Relationship Type</label>
      <div class="col-sm-10">
        <input type="text" class="form-control" placeholder="Type" bind="@CreateNewRelModel.Type" />
      </div>
    </div>
    <button class="btn btn-info" title="OK" type="submit"><i class="fas fa-check-square"></i></button>
  </EditForm>
      }
    }
  </section>

@functions {

  protected CreateNewRelModel CreateNewRelModel { get; set; } = new CreateNewRelModel();

  [Parameter]
  protected Document Document { get; set; }

  [Parameter]
  public Action DocumentDeleted { get; set; }

  private List<Product> RelatedProducts;

  protected List<Product> Products;
  protected string LeftState;
  protected string RightState;

  protected string DisabledLeft;
  protected string DisabledRight;

  protected string InputName;
  protected string InputDesignation;

  protected string NewVersionCheck;
  private bool ChangeState = false;

  protected bool AddState = false;
  public int PagesCount { get; set; } = 0;

  public int CurrentPage { get; set; } = 0;
  private string RelType;

  private string RelProduct;

  protected ChangeStateByDocumentVM ChangeStateByDocumentViewModel { get; set; }

  protected override async Task OnInitAsync()
  {
    WriteDownState();
    await CheckDocumentForCreateNewRevision();
    //string[] productIds = 
    RelatedProducts = await ConstructDocumentService.GetRelatedProducts(Document.Id);
  }
  private async void ChangeAddState()
  {
    AddState = true;
    var result = await ProductCardService.GetProductsOfFirstPageAsync();
    Products = result.Products;
    CurrentPage = 0;
    PagesCount = result.Pages;

    StateHasChanged();
  }
  private void WriteDownState()
  {
    switch(Document.State){
      case "In Check":
        LeftState = "In Work";
        RightState = "Approved";
        break;
      case "In Work":
        LeftState = null;
        DisabledLeft = "disabled";
        RightState = "In Check";
        break;
      case "Approved":
        LeftState = null;
        DisabledLeft = "disabled";
        RightState = "Outdated";
        break;
      case "Outdated":
        DisabledLeft = "disabled";
        DisabledRight = "disabled";
        LeftState = null;
        RightState = null;
        break;
    }
  }

  private void ChangePageState(bool tmp)
  {
    ChangeState = tmp;
  }

  private void SelectProductForRel(Product product)
  {
    RelProduct = product.Id;
  }

  private async Task Remove(string id)
  {
    await ConstructDocumentService.RemoveDocumentAsync(id);
    DocumentDeleted.Invoke();
  }

  private async Task ChangeDocumentState(string State, string Id)
  {
    await ConstructDocumentService.ChangeStateAsync(new ChangeStateByDocumentVM(Id,State));
    Document = await ConstructDocumentService.GetDataAsync(Id);
    WriteDownState();
    StateHasChanged();
    await CheckDocumentForCreateNewRevision();

  }

  private async Task CreateNewVersionDocument()
  {
    Console.WriteLine(Document.Id);
    string NewId = await ConstructDocumentService.CreateNewRevAsync(Document.Id);
    Console.WriteLine("NewId = " + NewId);
    Document = await ConstructDocumentService.GetDataAsync(NewId);
    WriteDownState();
    StateHasChanged();
  }

  private async Task CheckDocumentForCreateNewRevision()
  {
    Console.WriteLine("START");
    if ( await ConstructDocumentService.CheckDocumentForCreateNewRevision(Document.Id) != "true")
    {
      NewVersionCheck = "disabled";
    }
    Console.WriteLine(NewVersionCheck);
    StateHasChanged();
  }

  private async Task CreateNewRelAsync()
  {
    
    Console.WriteLine("START");
    await ConstructDocumentService.ConnectProductToDocument(new Relationship()
    {
      DocumentId = Document.Id,
      ProductId = RelProduct,
      Type = CreateNewRelModel.Type
    });
   
    Console.WriteLine("End");
    AddState = false;
    RelatedProducts = await ConstructDocumentService.GetRelatedProducts(Document.Id);
    StateHasChanged();
  }
}